################################
### Configuration testing
################################

# There are two versions because of rm/del, different echo behavior and path
# separator

ifdef DOS_SHELL
### DOS version
config-clean:
	-del $(SRCDIR)\config.inc

gcc_template_bug:
	@echo // Autogenerated: do not hand edit >> $(SRCDIR)\config.inc
	@echo #define __USE_MALLOC >> $(SRCDIR)\config.inc
	$(CC) -DTEST_GCC_TEMPLATE_BUG test/test.cc -o test/test$(EXE)
	@echo #undef __USE_MALLOC >> $(SRCDIR)\config.inc
	-del test\test$(EXE)

else
### Unix/sh version
config-clean:
	-rm $(SRCDIR)/config.inc

gcc_template_bug:
	@echo // Autogenerated: do not hand edit >> $(SRCDIR)/config.inc
	@echo \#define __USE_MALLOC >> $(SRCDIR)/config.inc
	$(CC) -DTEST_GCC_TEMPLATE_BUG test/test.cc -o test/test$(EXE)
	@echo \#undef __USE_MALLOC >> $(SRCDIR)/config.inc
	-rm test/test$(EXE)
endif


$(SRCDIR)/config.inc:
	@echo Testing for gcc static template member initialization bug
	-$(MAKE) config-clean
	-$(MAKE) gcc_template_bug


.PHONY: config-clean gcc_template_bug

# vim: syntax=make noet
